## zlib 1.2.12.1

=== debian/changelog ===
zlib (1:1.2.12.1-1+eagle) unstable; urgency=low

  * ['Autobuild release-candidate: bab1386d6bf908890bb36aa2457e7f4eb67f65a3']

 -- shuttle <shuttle@deepin.com>  Wed, 17 Jun 2020 13:28:07 +0000

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_OS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CFLAGS = `dpkg-buildflags --get CFLAGS` `dpkg-buildflags --get CPPFLAGS` -Wall -D_REENTRANT
LDFLAGS = `dpkg-buildflags --get LDFLAGS`

# binutils doesn't supply the prefixed version normally like GCC does so
# we can't just unconditionally use DEB_HOST_GNU_TYPE-ar
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	AR=ar
else
	AR=$(DEB_HOST_GNU_TYPE)-ar
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O3
endif

ifeq (,$(filter stage1,$(DEB_BUILD_PROFILES)))

32-ARCHS=amd64 ppc64 kfreebsd-amd64 s390x
64-ARCHS=s390 sparc i386 powerpc mips mipsel

ifneq (,$(findstring $(DEB_HOST_ARCH), $(32-ARCHS)))
EXTRA_INSTALL=install32
EXTRA_BUILD=build32-stamp
# s390x fails at compatibility.
ifneq (,$(findstring $(DEB_HOST_ARCH), s390x))
m32=-m31
else
m32=-m32
endif
endif

ifneq (,$(findstring $(DEB_HOST_ARCH), arm64))
	CFLAGS += -DCRC32_ARMV8_CRC32 -DHASH_ARMV8_CRC32 -march=armv8-a+crc -DUNALIGNED_OK -DADLER32_SIMD_NEON -DSLIDE_HASH_NEON -DINFLATE_CHUNK_SIMD_NEON
endif

ifneq (,$(findstring s390x, $(DEB_HOST_ARCH)))
else
ifneq (,$(findstring $(DEB_HOST_ARCH), $(64-ARCHS)))
EXTRA_INSTALL=install64
EXTRA_BUILD=build64-stamp
# MIPS doesn't use -m64
ifneq (,$(findstring $(DEB_HOST_ARCH), mips mipsel))
m64=-mabi=64
else
m64=-m64
endif
endif
endif

N32-ARCHS=mips mipsel
ifneq (,$(findstring $(DEB_HOST_ARCH), $(N32-ARCHS)))
EXTRA_INSTALL+=installn32
EXTRA_BUILD+=buildn32-stamp
mn32=-mabi=n32
endif

endif # !stage1

UNALIGNED_ARCHS=i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 lpia
ifneq (,$(findstring $(DEB_HOST_ARCH), $(UNALIGNED_ARCHS)))
CFLAGS+=-DUNALIGNED_OK
endif

ifneq (,$(filter mips mipsel mips64 mips64el,$(DEB_HOST_GNU_CPU)))
CFLAGS += -DENABLE_MMI -march=loongson3a -O3
endif


COPYLIST=*.h *.c *.in zlib.map configure zlib.3 test

configure-stamp: configure
	dh_testdir

	if [ ! -f Makefile.stash ]; then cp Makefile Makefile.stash ; fi

	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

	touch $@

configure64-stamp: configure
	dh_testdir

	mkdir -p debian/64
	cp -r $(COPYLIST) debian/64
	cd debian/64 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m64)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr  --libdir=\$${prefix}/usr/lib64
	touch $@

configure32-stamp: configure
	dh_testdir

	mkdir -p debian/32
	cp -r $(COPYLIST) debian/32
	cd debian/32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
	touch $@

configuren32-stamp: configure
	dh_testdir

	mkdir -p debian/n32
	cp -r $(COPYLIST) debian/n32
	cd debian/n32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mn32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
	touch $@

build: build-stamp $(EXTRA_BUILD)
build-stamp: configure-stamp
	dh_testdir

	$(MAKE)
	-$(MAKE) test

	touch $@

build64-stamp: configure64-stamp
	dh_testdir
	make -C debian/64
	touch $@

build32-stamp: configure32-stamp
	dh_testdir
	make -C debian/32
	touch $@

buildn32-stamp: configuren32-stamp
	dh_testdir
	make -C debian/n32
	touch $@

clean:
	dh_testdir
	dh_testroot

	$(MAKE) distclean

	rm -f build-stamp configure-stamp foo.gz 
	rm -rf debian/64 build64-stamp configure64-stamp
	rm -rf debian/32 build32-stamp configure32-stamp
	rm -rf debian/n32 buildn32-stamp configuren32-stamp
	-mv Makefile.stash Makefile
	-mv zlibdefs.h.stash zlibdefs.h

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install

	install -d debian/tmp/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so.* debian/tmp/lib/$(DEB_HOST_MULTIARCH)
	ln -sf /lib/$(DEB_HOST_MULTIARCH)/$$(readlink debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so

install64: install build64-stamp
	$(MAKE) -C debian/64 prefix=$(CURDIR)/debian/tmp install

install32: install build32-stamp
	$(MAKE) -C debian/32 prefix=$(CURDIR)/debian/tmp install

installn32: install buildn32-stamp
	$(MAKE) -C debian/n32 prefix=$(CURDIR)/debian/tmp install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install $(EXTRA_INSTALL)
	dh_testdir
	dh_testroot
	dh_installchangelogs -s ChangeLog
	dh_installdocs -s
	dh_installexamples -s
	dh_install -s --sourcedir=debian/tmp
	dh_installman -s
	dh_lintian -s
	dh_link -s
	dh_strip -s --dbg-package=zlib1g-dbg
	dh_compress -s
	dh_fixperms -s
	dh_makeshlibs -pzlib1g -V"zlib1g (>= 1:1.2.3.3.dfsg-1)" --add-udeb=zlib1g-udeb
ifeq (,$(filter stage1,$(DEB_BUILD_PROFILES)))
ifneq (,$(findstring $(DEB_HOST_ARCH), $(32-ARCHS)))
	dh_makeshlibs -plib32z1 -V"lib32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), $(64-ARCHS)))
	dh_makeshlibs -plib64z1 -V"lib64z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), $(N32-ARCHS)))
	dh_makeshlibs -plibn32z1 -V"libn32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
endif
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s
	dh_md5sums -s
	dh_builddeb -s

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install install64 install32

## zlib 1.2.12.5

=== debian/changelog ===
zlib (1:1.2.12.5-1+dde) unstable; urgency=medium

  * Fix CVE-2022-37434

 -- zhaochengyi <zhaochengyi@uniontech.com>  Thu, 27 Oct 2022 19:29:06 +0800

zlib (1:1.2.12.4-1+dde) unstable; urgency=low

  * update changelog

 -- yuxiaoping <yuxiaoping@uniontech.com>  Fri, 5 Apr 2022 18:20:23 +0800

zlib (1:1.2.12.3-1+dde) unstable; urgency=low

  * Add CVE-2018-25032 patch

 -- yuxiaoping <yuxiaoping@uniontech.com>  Wed, 14 Apr 2022 11:30:23 +0800

zlib (1:1.2.12.2-1+dde) unstable; urgency=low

  * Add update-patch-from-huawei-to-fix-crc32-hash-error.patch

 -- caitongxun <caitongxun@uniontech.com>  Sun, 07 Feb 2021 15:16:23 +0800

=== debian/rules ===
--- 
+++ 
@@ -51,7 +51,7 @@
 endif
 
 ifneq (,$(findstring $(DEB_HOST_ARCH), arm64))
-	CFLAGS += -DCRC32_ARMV8_CRC32 -DHASH_ARMV8_CRC32 -march=armv8-a+crc -DUNALIGNED_OK -DADLER32_SIMD_NEON -DSLIDE_HASH_NEON -DINFLATE_CHUNK_SIMD_NEON
+	CFLAGS += -DCRC32_ARMV8_CRC32 -march=armv8-a+crc -DUNALIGNED_OK -DADLER32_SIMD_NEON -DSLIDE_HASH_NEON -DINFLATE_CHUNK_SIMD_NEON -O3
 endif
 
 ifneq (,$(findstring s390x, $(DEB_HOST_ARCH)))

## zlib 1.2.13.dfsg

=== debian/changelog ===
zlib (1:1.2.13.dfsg-1ubuntu5) mantic; urgency=medium

  * Add
    d/p/lp-2018293-fix-crash-in-deflateBound-if-called-before-deflateInt.patch
    to avoid potential deflateBound() function crash on s390x.
  * Clean-up and remove
    d/p/lp1932010-ibm-z-add-vectorized-crc32-implementation.patch since it was
    replaced by d/p/s390x-vectorize-crc32.patch with 1.2.13.dfsg-1ubuntu3
    but was still in d/p/ (but not in d/p/series). 

 -- Frank Heimes <frank.heimes@canonical.com>  Wed, 02 Aug 2023 13:22:26 +0200

zlib (1:1.2.13.dfsg-1ubuntu4) lunar; urgency=medium

  * Add d/p/1390.patch to not update strm.adler for raw streams on s390x 
    (DFLTCC), otherwise libxml2 gets broken on s390x. LP: #2002511

 -- Frank Heimes <frank.heimes@canonical.com>  Wed, 11 Jan 2023 18:02:34 +0100

zlib (1:1.2.13.dfsg-1ubuntu3) lunar; urgency=medium
  
  * Re-add vectorized crc32 support for s390x by adding
    d/p/s390x-vectorize-crc32.patch
    (crc32vx-v4: s390x: vectorize crc32). (LP: #1998470)
    This replaces the previously dropped patch:
    lp1932010-ibm-z-add-vectorized-crc32-implementation.patch
  * Remove option '--crc32-vx' for s390x in d/rules, that was previously just
    commented out, since it's no longer needed with the new s390x crc32 code.
  * Update d/p/410.patch to version 26f2c0a4e17e5558d779797d713aa37ebaeef390
    due to unused "const char *endptr;".

 -- Frank Heimes <frank.heimes@canonical.com>  Mon, 21 Nov 2022 20:28:58 +0100

zlib (1:1.2.13.dfsg-1ubuntu2) lunar; urgency=medium

  * Comment out use of --crc32-vx on s390x, since this is currently not
    implemented due to the dropped patch that needs porting.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 15 Nov 2022 17:06:45 +0000

zlib (1:1.2.13.dfsg-1ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Build x32 packages
    - debian/zlib-core.symbols: Drop dfsg suffix from version
    - Add watch file, with GPG tarball checking, and version mangling
    - Cherrypick PR#410 to enable hardware-accelerated deflate.
    - Copmile with DFLTCC enabled on s390x.
    - Enable hardware compression on s390x at level 6.
    - d/rules: use configure options for dfltcc instead of hardcoding
       the CFLAGS
  * Dropped changes, included upstream:
    - Cherry-pick Permit-a-deflateParams-parameter-change-asap.patch
    - debian/patches/CVE-2018-25032-2.patch: assure that the number of bits
      for deflatePrime() is valid in deflate.c.
  * Pull rebased 410.patch from https://github.com/madler/zlib/pull/410.
  * Drop d/p/410-lp1961427.patch, included in the above rebase.
  * Replace 335.patch for ppc64el (P8) crc32 performance with 478.patch which
    supersedes it (https://github.com/madler/zlib/pull/478).
  * Forward-port lp1932010-ibm-z-add-vectorized-crc32-implementation.patch.
  * Dropped changes:
    - d/p/lp1932010-ibm-z-add-vectorized-crc32-implementation.patch: this
      patch depends on zlib upstream PR 335 which has been superseded by
      upstream PR 478 with significant refactoring.  Drop this patch,
      pending a port from IBM.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 07 Nov 2022 15:57:28 -0800

zlib (1:1.2.13.dfsg-1) unstable; urgency=low

  * New upstream release.
  * Remove non-DFSG sources for contrib/testzlib (closes: #1012674).
  * Policy 4.6.1 (no changes).

 -- Mark Brown <broonie@debian.org>  Sat, 05 Nov 2022 12:24:46 +0000

=== debian/control ===
Source: zlib
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mark Brown <broonie@debian.org>
Standards-Version: 4.6.1
Homepage: http://zlib.net/
Build-Depends: debhelper (>= 13), gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc s390x mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64 mips64el mips64r6 mips64r6el x32] <!nobiarch>, dpkg-dev (>= 1.16.1)

Package: zlib1g
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Priority: required
Conflicts: zlib1 (<= 1:1.0.4-7)
Breaks: libxml2 (<< 2.7.6.dfsg-2), texlive-binaries (<< 2009-12)
Provides: libz1
Description: compression library - runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the shared library.

Package: zlib1g-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: zlib1g (= ${binary:Version}), libc6-dev | libc-dev, ${misc:Depends}
Conflicts: zlib1-dev
Provides: libz-dev
Description: compression library - development
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files.

Package: zlib1g-udeb
XC-Package-Type: udeb
Architecture: any
Priority: optional
Section: debian-installer
Description: compression library - runtime for Debian installer
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This minimal package includes the shared library
 for use with the Debian installer.

Package: lib64z1
Architecture: sparc s390 i386 powerpc mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el x32
Build-Profiles: <!nobiarch>
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: amd64-libs (<< 1.4)
Description: compression library - 64 bit runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes a 64 bit version of the
 shared library.

Package: lib64z1-dev
Section: libdevel
Architecture: sparc s390 i386 powerpc mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el x32
Build-Profiles: <!nobiarch>
Depends: lib64z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib64c-dev, ${misc:Depends}
Replaces: amd64-libs-dev (<< 1.4)
Provides: lib64z-dev
Description: compression library - 64 bit - DO NOT USE EXCEPT FOR PACKAGING
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files for building 64 bit applications.
 .
 This package should ONLY be used for building packages, users who do
 not need to build packages should use multiarch to install the relevant
 runtime.

Package: lib32z1
Architecture: amd64 ppc64 kfreebsd-amd64 s390x
Build-Profiles: <!nobiarch>
Conflicts: libc6-i386 (<= 2.9-18)
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: ia32-libs (<< 1.5)
Description: compression library - 32 bit runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes a 32 bit version of the
 shared library.

Package: lib32z1-dev
Section: libdevel
Architecture: amd64 ppc64 kfreebsd-amd64 s390x
Build-Profiles: <!nobiarch>
Conflicts: libc6-i386 (<= 2.9-18)
Depends: lib32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib32c-dev, ${misc:Depends}
Provides: lib32z-dev
Replaces: ia32-libs-dev (<< 1.5)
Description: compression library - 32 bit - DO NOT USE EXCEPT FOR PACKAGING
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files for building 32 bit applications.
 .
 This package should ONLY be used for building packages, users who do
 not need to build packages should use multiarch to install the relevant
 runtime.

Package: libn32z1
Architecture: mips mipsel
Build-Profiles: <!nobiarch>
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: compression library - n32 runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes a n32 version of the shared
 library.

Package: libn32z1-dev
Section: libdevel
Architecture: mips mipsel
Build-Profiles: <!nobiarch>
Depends: libn32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), libn32c-dev, ${misc:Depends}
Provides: libn32z-dev
Description: compression library - n32 - DO NOT USE EXCEPT FOR PACKAGING
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files for building n32 applications.
 .
 This package should ONLY be used for building packages, users who do
 not need to build packages should use multiarch to install the relevant
 runtime.

Package: libx32z1
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: compression library - x32 runtime
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes a n32 version of the shared
 library.

Package: libx32z1-dev
Section: libdevel
Architecture: amd64 i386
Depends: libx32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), libc6-dev-x32, ${misc:Depends}
Provides: libx32z-dev
Description: compression library - x32 - DO NOT USE EXCEPT FOR PACKAGING
 zlib is a library implementing the deflate compression method found
 in gzip and PKZIP.  This package includes the development support
 files for building n32 applications.
 .
 This package should ONLY be used for building packages, users who do
 not need to build packages should use multiarch to install the relevant
 runtime.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_OS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CFLAGS = `dpkg-buildflags --get CFLAGS` `dpkg-buildflags --get CPPFLAGS` -Wall -D_REENTRANT
LDFLAGS = `dpkg-buildflags --get LDFLAGS`
EXTRA_MAKE =

CONFIGURE_COMMON=--shared --prefix=/usr
CONFIGURE_HOST=--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)

# binutils doesn't supply the prefixed version normally like GCC does so
# we can't just unconditionally use DEB_HOST_GNU_TYPE-ar
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	AR=ar
else
	AR=$(DEB_HOST_GNU_TYPE)-ar
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O3
endif

ifeq (,$(filter nobiarch,$(DEB_BUILD_PROFILES)))

32-ARCHS=amd64 ppc64 kfreebsd-amd64 s390x
64-ARCHS=s390 sparc i386 powerpc mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el x32

ifneq (,$(filter $(DEB_HOST_ARCH), $(32-ARCHS)))
EXTRA_INSTALL=install32
EXTRA_BUILD=build32-stamp
# s390x fails at compatibility.
ifneq (,$(filter $(DEB_HOST_ARCH), s390x))
m32=-m31
CFLAGS += -DDFLTCC_LEVEL_MASK=0x7e
CONFIGURE_COMMON += --dfltcc
else
m32=-m32
endif
endif

ifneq (,$(filter s390x, $(DEB_HOST_ARCH)))
else
ifneq (,$(filter $(DEB_HOST_ARCH), $(64-ARCHS)))
EXTRA_INSTALL=install64
EXTRA_BUILD=build64-stamp
# MIPS doesn't use -m64
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el))
m64=-mabi=64
else
m64=-m64
endif
endif
endif

N32-ARCHS=mips mipsel
ifneq (,$(filter $(DEB_HOST_ARCH), $(N32-ARCHS)))
EXTRA_INSTALL+=installn32
EXTRA_BUILD+=buildn32-stamp
mn32=-mabi=n32
endif

endif # !nobiarch

X32-ARCHS=amd64 i386
ifneq (,$(findstring $(DEB_HOST_ARCH), $(X32-ARCHS)))
EXTRA_INSTALL+=installx32
EXTRA_BUILD+=buildx32-stamp
mx32=-mx32
endif

UNALIGNED_ARCHS=i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 lpia
ifneq (,$(filter $(DEB_HOST_ARCH), $(UNALIGNED_ARCHS)))
CFLAGS+=-DUNALIGNED_OK
endif

COPYLIST=*.h *.c *.in zlib.map configure zlib.3 test contrib

configure-stamp: configure
	dh_testdir

	if [ ! -f Makefile.stash ]; then cp Makefile Makefile.stash ; fi

	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" uname=GNU ./configure $(CONFIGURE_COMMON) $(CONFIGURE_HOST)

	touch $@

configure64-stamp: configure
	dh_testdir

	mkdir -p debian/64
	cp -r $(COPYLIST) debian/64
	cd debian/64 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m64)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/lib64
	touch $@

configure32-stamp: configure
	dh_testdir

	mkdir -p debian/32
	cp -r $(COPYLIST) debian/32
	cd debian/32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/lib32
	touch $@

configuren32-stamp: configure
	dh_testdir

	mkdir -p debian/n32
	cp -r $(COPYLIST) debian/n32
	cd debian/n32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mn32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/lib32
	touch $@

configurex32-stamp: configure
	dh_testdir

	mkdir -p debian/x32
	cp -r $(COPYLIST) debian/x32
	cd debian/x32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mx32)" \
	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/libx32
	touch $@

build: build-arch build-indep
build-indep:

build-arch: build-stamp $(EXTRA_BUILD)
build-stamp: configure-stamp
	dh_testdir

	$(MAKE) $(EXTRA_MAKE)
	-$(MAKE) test

	touch $@

build64-stamp: configure64-stamp
	dh_testdir
	make -C debian/64
	touch $@

build32-stamp: configure32-stamp
	dh_testdir
	make -C debian/32 $(EXTRA_MAKE)
	touch $@

buildn32-stamp: configuren32-stamp
	dh_testdir
	make -C debian/n32
	touch $@

buildx32-stamp: configurex32-stamp
	dh_testdir
	make -C debian/x32
	touch $@

clean:
	dh_testdir
	dh_testroot

	$(MAKE) distclean

	rm -f build-stamp configure-stamp foo.gz 
	rm -rf debian/64 build64-stamp configure64-stamp
	rm -rf debian/32 build32-stamp configure32-stamp
	rm -rf debian/n32 buildn32-stamp configuren32-stamp
	rm -rf debian/x32 buildx32-stamp configurex32-stamp
	-mv Makefile.stash Makefile
	-mv zlibdefs.h.stash zlibdefs.h

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install

	install -d debian/tmp/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so.* debian/tmp/lib/$(DEB_HOST_MULTIARCH)
	ln -sf /lib/$(DEB_HOST_MULTIARCH)/$$(readlink debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so

install64: install build64-stamp
	$(MAKE) -C debian/64 prefix=$(CURDIR)/debian/tmp install

install32: install build32-stamp
	$(MAKE) -C debian/32 prefix=$(CURDIR)/debian/tmp install

installn32: install buildn32-stamp
	$(MAKE) -C debian/n32 prefix=$(CURDIR)/debian/tmp install

installx32: install buildx32-stamp
	$(MAKE) -C debian/x32 prefix=$(CURDIR)/debian/tmp install

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install $(EXTRA_INSTALL)
	dh_testdir
	dh_testroot
	dh_installchangelogs -a ChangeLog
	dh_installdocs -a
	dh_installexamples -a
	dh_install -a --sourcedir=debian/tmp
	dh_installman -a
	dh_lintian -a
	dh_link -a
	dh_strip -a --dbgsym-migration="zlib1g-dbg (<< 1:1.2.11.dfsg-2~)"
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -pzlib1g -V"zlib1g (>= 1:1.2.3.3.dfsg-1)" --add-udeb=zlib1g-udeb
ifeq (,$(filter nobiarch,$(DEB_BUILD_PROFILES)))
ifneq (,$(filter $(DEB_HOST_ARCH), $(32-ARCHS)))
	dh_makeshlibs -plib32z1 -V"lib32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(filter $(DEB_HOST_ARCH), $(64-ARCHS)))
	dh_makeshlibs -plib64z1 -V"lib64z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(filter $(DEB_HOST_ARCH), $(N32-ARCHS)))
	dh_makeshlibs -plibn32z1 -V"libn32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), $(X32-ARCHS)))
	dh_makeshlibs -plibx32z1 -V"libx32z1 (>= 1:1.2.3.3.dfsg-1)"
endif
endif
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install install64 install32

## zlib 1.03-1

=== Makefile ===
# Makefile for zlib
# Copyright (C) 1995-1996 Jean-loup Gailly.
# For conditions of distribution and use, see copyright notice in zlib.h 

# To compile and test, type:
#   ./configure; make test
# The call of configure is optional if you don't have special requirements

# To install /usr/local/lib/libz.* and /usr/local/include/zlib.h, type:
#    make install
# To install in $HOME instead of /usr/local, use:
#    make install prefix=$HOME

CC=gcc

#CFLAGS=-O
#CFLAGS=-O -DMAX_WBITS=14 -DMAX_MEM_LEVEL=7
#CFLAGS=-g -DDEBUG
CFLAGS=-O3 -Wall -Wwrite-strings -Wpointer-arith -Wconversion \
           -Wstrict-prototypes -Wmissing-prototypes

LDFLAGS=-L. -lz
LDSHARED=$(CC) -shared

VER=1.0.3
SONAME=1
LIBS=libz.a
LIBS=libz.a libz.so.$(VER)

AR=ar rc
RANLIB=ranlib
TAR=tar

prefix=/usr/local
exec_prefix = $(prefix)

OBJS = adler32.o compress.o crc32.o gzio.o uncompr.o deflate.o trees.o \
       zutil.o inflate.o infblock.o inftrees.o infcodes.o infutil.o inffast.o

TEST_OBJS = example.o minigzip.o

DISTFILES = README INDEX ChangeLog configure Make*[a-z0-9] descrip.mms \
	    zlib.def zlib.rc algorithm.doc  *.[ch]

all: example minigzip

test: all
	./example
	echo hello world | ./minigzip | ./minigzip -d 

libs: shared $(LIBS)

shared:
	mkdir shared

libz.a: $(OBJS)
	$(AR) $@ $(OBJS)
	-@ ($(RANLIB) $@ || true) 2>/dev/null

libz.so.$(VER): $(OBJS)
	cd shared && $(LDSHARED) -Wl,-soname,libz.so.$(SONAME) -o ../$@ $(OBJS)

example: example.o $(LIBS)
	$(CC) $(CFLAGS) -o $@ example.o $(LDFLAGS)

minigzip: minigzip.o $(LIBS)
	$(CC) $(CFLAGS) -o $@ minigzip.o $(LDFLAGS)

install: $(LIBS)
	-@if [ ! $(prefix)/include  ]; then mkdir $(prefix)/include; fi
	-@if [ ! $(exec_prefix)/lib ]; then mkdir $(exec_prefix)/lib; fi
	cp zlib.h zconf.h $(prefix)/include
	chmod 644 $(prefix)/include/zlib.h $(prefix)/include/zconf.h
	cp $(LIBS) $(exec_prefix)/lib
	cd $(exec_prefix)/lib; chmod 644 $(LIBS)
	-@(cd $(exec_prefix)/lib; $(RANLIB) libz.a || true) >/dev/null 2>&1
	cd $(exec_prefix)/lib; if test -f libz.so.$(VER); then \
	  ln -s libz.so.$(VER) libz.so; \
	fi
# The ranlib in install is needed on NeXTSTEP which checks file times

uninstall:
	cd $(exec_prefix)/lib; rm -f $(LIBS); \
	if test -f libz.so; then \
	 v=`sed -n '/VERSION "/s/.*"\(.*\)".*/\1/p'<$(prefix)/include/zlib.h`;\
	 rm -f libz.so.$$v libz.so; \
	fi
	cd $(prefix)/include; rm -f zlib.h zconf.h

clean:
	rm -f *.o shared/*.o *~ example minigzip foo.gz libz.a libz.so*
	rmdir shared

zip:
	mv Makefile Makefile~; cp -p Makefile.in Makefile
	v=`sed -n -e 's/\.//g' -e '/VERSION "/s/.*"\(.*\)".*/\1/p' < zlib.h`;\
	zip -ul9 zlib$$v $(DISTFILES)
	mv Makefile~ Makefile

dist:
	mv Makefile Makefile~; cp -p Makefile.in Makefile
	d=zlib-`sed -n '/VERSION "/s/.*"\(.*\)".*/\1/p' < zlib.h`;\
	rm -f $$d.tar.gz; \
	if test ! -d ../$$d; then rm -f ../$$d; ln -s `pwd` ../$$d; fi; \
	files=""; \
	for f in $(DISTFILES); do files="$$files $$d/$$f"; done; \
	cd ..; \
	GZIP=-9 $(TAR) chofz $$d/$$d.tar.gz $$files; \
	if test ! -d $$d; then rm -f $$d; fi
	mv Makefile~ Makefile

tags:	
	etags *.[ch]

depend:
	makedepend -- $(CFLAGS) -- *.[ch]

# This rule allows us to compile for shared libs & static all at once
.c.o:
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $(SLFLAGS) -o shared/$@ $*.c
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $*.c

# DO NOT DELETE THIS LINE -- make depend depends on it.

adler32.o: zlib.h zconf.h
compress.o: zlib.h zconf.h
crc32.o: zlib.h zconf.h
deflate.o: deflate.h zutil.h zlib.h zconf.h
example.o: zlib.h zconf.h
gzio.o: zutil.h zlib.h zconf.h
infblock.o: infblock.h inftrees.h infcodes.h infutil.h zutil.h zlib.h zconf.h
infcodes.o: zutil.h zlib.h zconf.h
infcodes.o: inftrees.h infblock.h infcodes.h infutil.h inffast.h
inffast.o: zutil.h zlib.h zconf.h inftrees.h
inffast.o: infblock.h infcodes.h infutil.h inffast.h
inflate.o: zutil.h zlib.h zconf.h infblock.h
inftrees.o: zutil.h zlib.h zconf.h inftrees.h
infutil.o: zutil.h zlib.h zconf.h infblock.h inftrees.h infcodes.h infutil.h
minigzip.o:  zlib.h zconf.h 
trees.o: deflate.h zutil.h zlib.h zconf.h 
uncompr.o: zlib.h zconf.h
zutil.o: zutil.h zlib.h zconf.h

## zlib 1.3.dfsg

=== debian/changelog ===
zlib (1:1.3.dfsg-3ubuntu1) noble; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Build x32 packages
    - Add watch file, with GPG tarball checking, and version mangling
    - d/rules: Compile with DFLTCC enabled on s390x and hardware
      compression at level 6
    - d/zlib-core.symbols: Drop dfsg suffix from version
  * New patches rebased from iii-i/zlib/dfltcc on GitHub:
    - d/p/power/*: Add optimized crc32 for POWER8+
    - d/p/s390x/*: Add optimized crc32 and hardware deflate
  * Patches superseded by the above:
    - d/p/410.patch: Add support for IBM Z hardware-accelerated deflate
    - d/p/478.patch: Add optimized crc32 for Power 8+ processors
    - d/p/s390x-vectorize-crc32.patch: Add s390x vectorized crc32 support
    - d/p/1390.patch: Don't update strm.adler for raw streams on s390x
      (DFLTCC), otherwise libxml2 gets broken on s390x. LP #2002511
    - d/p/lp-2018293-fix-crash-in-deflateBound-if-called-before-deflateInt
      .patch: Avoid potential deflateBound() function crash on s390x

 -- Mate Kukri <mate.kukri@canonical.com>  Fri, 24 Nov 2023 08:22:52 +0000

zlib (1:1.3.dfsg-3) unstable; urgency=low

  * Update the version of texlive-binaries we break since they still had
    broken version checks (closes: #1056312).

 -- Mark Brown <broonie@debian.org>  Thu, 23 Nov 2023 13:02:20 +0000

zlib (1:1.3.dfsg-2) unstable; urgency=low

  * Install library into /usr (closes: #1055938).
  * Backport patch for minizip CVE-2023-45853 (closes: #1054290).

 -- Mark Brown <broonie@debian.org>  Fri, 17 Nov 2023 22:10:10 +0000

zlib (1:1.3.dfsg-1) unstable; urgency=low

  * New upstream release.

 -- Mark Brown <broonie@debian.org>  Mon, 06 Nov 2023 16:28:55 +0000

zlib (1:1.2.13.dfsg-3) unstable; urgency=low

  * Further fixes to the minizip integration, don't install the minizip
    headers in both -dev packages (closes: #1049384).

 -- Mark Brown <broonie@debian.org>  Tue, 15 Aug 2023 14:35:28 +0100

zlib (1:1.2.13.dfsg-2) unstable; urgency=low

  * Build minizip packages since for some reason the minizip upstream
    appears to have decided to release via zlib's contrib directiory
    and do nothing separate, patch from Michael Gilbert adapted to fix
    build issues (closes: #956181).

 -- Mark Brown <broonie@debian.org>  Tue, 15 Aug 2023 00:28:42 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 XSBC-Original-Maintainer: Mark Brown <broonie@debian.org>
 Standards-Version: 4.6.1
 Homepage: http://zlib.net/
-Build-Depends: debhelper (>= 13), gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc s390x mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64 mips64el mips64r6 mips64r6el x32] <!nobiarch>, dpkg-dev (>= 1.16.1)
+Build-Depends: debhelper (>= 13), gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc s390x mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64 mips64el mips64r6 mips64r6el x32] <!nobiarch>, dpkg-dev (>= 1.16.1), autoconf
 
 Package: zlib1g
 Architecture: any
@@ -14,7 +14,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Priority: required
 Conflicts: zlib1 (<= 1:1.0.4-7)
-Breaks: libxml2 (<< 2.7.6.dfsg-2), texlive-binaries (<< 2009-12)
+Breaks: libxml2 (<< 2.7.6.dfsg-2), texlive-binaries (<< 2023.20230311.66589-8)
 Provides: libz1
 Description: compression library - runtime
  zlib is a library implementing the deflate compression method found
@@ -141,3 +141,50 @@
  This package should ONLY be used for building packages, users who do
  not need to build packages should use multiarch to install the relevant
  runtime.
+
+Package: minizip
+Section: utils
+Architecture: any
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Replaces:
+ zlib-bin,
+Conflicts:
+ zlib-bin,
+Description: compression library - minizip tools
+ minizip is a minimalistic library that supports compressing, extracting,
+ viewing, and manipulating zip files.
+ .
+ This package includes the minizip and miniunzip tools.
+
+Package: libminizip1
+Architecture: any
+Multi-Arch: same
+Pre-Depends:
+ ${misc:Pre-Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Description: compression library - minizip library
+ minizip is a minimalistic library that supports compressing, extracting,
+ viewing, and manipulating zip files.
+ .
+ This package includes the minizip library.
+
+Package: libminizip-dev
+Architecture: any
+Multi-Arch: same
+Section: libdevel
+Depends:
+ ${misc:Depends},
+ libminizip1 (= ${binary:Version})
+Replaces:
+ libkml-dev (<< 1.3.0~r864+git20150723-0fa2f22-1~),
+Breaks:
+ libkml-dev (<< 1.3.0~r864+git20150723-0fa2f22-1~),
+Description: compression library - minizip development files
+ minizip is a minimalistic library that supports compressing, extracting,
+ viewing, and manipulating zip files.
+ .
+ This package includes development support files for the minizip library.

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,6 @@
 
 CFLAGS = `dpkg-buildflags --get CFLAGS` `dpkg-buildflags --get CPPFLAGS` -Wall -D_REENTRANT
 LDFLAGS = `dpkg-buildflags --get LDFLAGS`
-EXTRA_MAKE =
 
 CONFIGURE_COMMON=--shared --prefix=/usr
 CONFIGURE_HOST=--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
@@ -100,6 +99,8 @@
 
 	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" uname=GNU ./configure $(CONFIGURE_COMMON) $(CONFIGURE_HOST)
 
+	cd contrib/minizip && autoreconf -fis && CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" uname=GNU ./configure --prefix=/usr --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
+
 	touch $@
 
 configure64-stamp: configure
@@ -149,7 +150,10 @@
 build-stamp: configure-stamp
 	dh_testdir
 
-	$(MAKE) $(EXTRA_MAKE)
+	$(MAKE)
+
+	$(MAKE) -C contrib/minizip minizip miniunzip
+
 	-$(MAKE) test
 
 	touch $@
@@ -161,7 +165,7 @@
 
 build32-stamp: configure32-stamp
 	dh_testdir
-	make -C debian/32 $(EXTRA_MAKE)
+	make -C debian/32
 	touch $@
 
 buildn32-stamp: configuren32-stamp
@@ -177,6 +181,9 @@
 clean:
 	dh_testdir
 	dh_testroot
+
+	if [ -f contrib/minizip/Makefile ]; then $(MAKE) -C contrib/minizip clean; fi
+	cd contrib/minizip && rm -f compile config.* configure depcomp install-sh libtool Makefile Makefile.in aclocal.m4 ltmain.sh missing minizip.pc minizip miniunzip
 
 	$(MAKE) distclean
 
@@ -198,9 +205,8 @@
 
 	$(MAKE) prefix=$(CURDIR)/debian/tmp/usr install
 
-	install -d debian/tmp/lib/$(DEB_HOST_MULTIARCH)
-	mv debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so.* debian/tmp/lib/$(DEB_HOST_MULTIARCH)
-	ln -sf /lib/$(DEB_HOST_MULTIARCH)/$$(readlink debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libz.so
+	$(MAKE) -C contrib/minizip prefix=$(CURDIR)/debian/tmp/usr install
+	find contrib/minizip
 
 install64: install build64-stamp
 	$(MAKE) -C debian/64 prefix=$(CURDIR)/debian/tmp install
@@ -222,6 +228,9 @@
 binary-arch: build install $(EXTRA_INSTALL)
 	dh_testdir
 	dh_testroot
+	mkdir -p debian/tmp/usr/bin
+	cp contrib/minizip/.libs/minizip debian/tmp/usr/bin
+	cp contrib/minizip/.libs/miniunzip debian/tmp/usr/bin
 	dh_installchangelogs -a ChangeLog
 	dh_installdocs -a
 	dh_installexamples -a
@@ -232,6 +241,7 @@
 	dh_strip -a --dbgsym-migration="zlib1g-dbg (<< 1:1.2.11.dfsg-2~)"
 	dh_compress -a
 	dh_fixperms -a
+	dh_makeshlibs -plibminizip1 -V"libminizip1 (>> 1:1.2.13.dfsg-1)"
 	dh_makeshlibs -pzlib1g -V"zlib1g (>= 1:1.2.3.3.dfsg-1)" --add-udeb=zlib1g-udeb
 ifeq (,$(filter nobiarch,$(DEB_BUILD_PROFILES)))
 ifneq (,$(filter $(DEB_HOST_ARCH), $(32-ARCHS)))

## zlib 1.3.dfsg%2Breally1.3.1

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: zlib
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mark Brown <broonie@debian.org>
+Maintainer: Mark Brown <broonie@debian.org>
 Standards-Version: 4.6.1
 Homepage: http://zlib.net/
-Build-Depends: debhelper (>= 13), gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc s390x mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64 mips64el mips64r6 mips64r6el x32] <!nobiarch>, dpkg-dev (>= 1.16.1), autoconf
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 13), gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc s390x mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64 mips64el mips64r6 mips64r6el x32] <!nobiarch>, dpkg-dev (>= 1.16.1), autoconf
 
 Package: zlib1g
 Architecture: any
@@ -120,28 +119,6 @@
  not need to build packages should use multiarch to install the relevant
  runtime.
 
-Package: libx32z1
-Architecture: amd64 i386
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: compression library - x32 runtime
- zlib is a library implementing the deflate compression method found
- in gzip and PKZIP.  This package includes a n32 version of the shared
- library.
-
-Package: libx32z1-dev
-Section: libdevel
-Architecture: amd64 i386
-Depends: libx32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), libc6-dev-x32, ${misc:Depends}
-Provides: libx32z-dev
-Description: compression library - x32 - DO NOT USE EXCEPT FOR PACKAGING
- zlib is a library implementing the deflate compression method found
- in gzip and PKZIP.  This package includes the development support
- files for building n32 applications.
- .
- This package should ONLY be used for building packages, users who do
- not need to build packages should use multiarch to install the relevant
- runtime.
-
 Package: minizip
 Section: utils
 Architecture: any
@@ -158,7 +135,10 @@
  .
  This package includes the minizip and miniunzip tools.
 
-Package: libminizip1
+Package: libminizip1t64
+Provides: ${t64:Provides}
+Replaces: libminizip1
+Breaks: libminizip1 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -178,7 +158,7 @@
 Section: libdevel
 Depends:
  ${misc:Depends},
- libminizip1 (= ${binary:Version})
+ libminizip1t64 (= ${binary:Version})
 Replaces:
  libkml-dev (<< 1.3.0~r864+git20150723-0fa2f22-1~),
 Breaks:

## zlib 1.3.dfsg+really1.3.1

=== debian/changelog ===
zlib (1:1.3.dfsg+really1.3.1-3) unstable; urgency=low

  * Apply fixup for s390x removal from Helmut Grohne (closes: #1127743).

 -- Mark Brown <broonie@debian.org>  Mon, 16 Feb 2026 14:40:58 +0000

zlib (1:1.3.dfsg+really1.3.1-2) unstable; urgency=low

  * Stop building lib32z1 on s390x using patch from Aurelien Jarno
    <aurel32@debian.org>, due to an uncoordinated upload of gcc-defaults
    there will be some temporary problems with testing migration as
    things sort themselves out (closes: #1125669).
  * Flag that we support noudeb (closes: #1024936).
  * Enable autopkgtest using patch from Sahithi Akunuri
    <akunuri.sahithi@toshiba-tsip.com> (closes: #1113755).

 -- Mark Brown <broonie@debian.org>  Sat, 31 Jan 2026 12:50:16 +0000

zlib (1:1.3.dfsg+really1.3.1-1) unstable; urgency=low

  * New upstream release.

 -- Mark Brown <broonie@debian.org>  Fri, 10 May 2024 10:32:36 +0100

zlib (1:1.3.dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063242

 -- Benjamin Drung <bdrung@debian.org>  Fri, 01 Mar 2024 12:59:44 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Mark Brown <broonie@debian.org>
 Standards-Version: 4.6.1
 Homepage: http://zlib.net/
-Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 13), gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc s390x mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64 mips64el mips64r6 mips64r6el x32] <!nobiarch>, dpkg-dev (>= 1.16.1), autoconf
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 13), gcc-multilib [amd64 i386 kfreebsd-amd64 mips mipsel powerpc ppc64 s390 sparc mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el mips64 mips64el mips64r6 mips64r6el x32] <!nobiarch>, dpkg-dev (>= 1.16.1), autoconf
 
 Package: zlib1g
 Architecture: any
@@ -33,6 +33,7 @@
 
 Package: zlib1g-udeb
 XC-Package-Type: udeb
+Build-Profiles: <!noudeb>
 Architecture: any
 Priority: optional
 Section: debian-installer
@@ -68,7 +69,7 @@
  runtime.
 
 Package: lib32z1
-Architecture: amd64 ppc64 kfreebsd-amd64 s390x
+Architecture: amd64 ppc64 kfreebsd-amd64
 Build-Profiles: <!nobiarch>
 Conflicts: libc6-i386 (<= 2.9-18)
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -80,7 +81,7 @@
 
 Package: lib32z1-dev
 Section: libdevel
-Architecture: amd64 ppc64 kfreebsd-amd64 s390x
+Architecture: amd64 ppc64 kfreebsd-amd64
 Build-Profiles: <!nobiarch>
 Conflicts: libc6-i386 (<= 2.9-18)
 Depends: lib32z1 (= ${binary:Version}), zlib1g-dev (= ${binary:Version}), lib32c-dev, ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -20,9 +20,6 @@
 CFLAGS = `dpkg-buildflags --get CFLAGS` `dpkg-buildflags --get CPPFLAGS` -Wall -D_REENTRANT
 LDFLAGS = `dpkg-buildflags --get LDFLAGS`
 
-CONFIGURE_COMMON=--shared --prefix=/usr
-CONFIGURE_HOST=--libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
-
 # binutils doesn't supply the prefixed version normally like GCC does so
 # we can't just unconditionally use DEB_HOST_GNU_TYPE-ar
 ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
@@ -39,24 +36,15 @@
 
 ifeq (,$(filter nobiarch,$(DEB_BUILD_PROFILES)))
 
-32-ARCHS=amd64 ppc64 kfreebsd-amd64 s390x
+32-ARCHS=amd64 ppc64 kfreebsd-amd64
 64-ARCHS=s390 sparc i386 powerpc mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el x32
 
 ifneq (,$(filter $(DEB_HOST_ARCH), $(32-ARCHS)))
 EXTRA_INSTALL=install32
 EXTRA_BUILD=build32-stamp
-# s390x fails at compatibility.
-ifneq (,$(filter $(DEB_HOST_ARCH), s390x))
-m32=-m31
-CFLAGS += -DDFLTCC_LEVEL_MASK=0x7e
-CONFIGURE_COMMON += --dfltcc
-else
 m32=-m32
 endif
-endif
-
-ifneq (,$(filter s390x, $(DEB_HOST_ARCH)))
-else
+
 ifneq (,$(filter $(DEB_HOST_ARCH), $(64-ARCHS)))
 EXTRA_INSTALL=install64
 EXTRA_BUILD=build64-stamp
@@ -67,7 +55,6 @@
 m64=-m64
 endif
 endif
-endif
 
 N32-ARCHS=mips mipsel
 ifneq (,$(filter $(DEB_HOST_ARCH), $(N32-ARCHS)))
@@ -78,26 +65,19 @@
 
 endif # !nobiarch
 
-X32-ARCHS=amd64 i386
-ifneq (,$(findstring $(DEB_HOST_ARCH), $(X32-ARCHS)))
-EXTRA_INSTALL+=installx32
-EXTRA_BUILD+=buildx32-stamp
-mx32=-mx32
-endif
-
 UNALIGNED_ARCHS=i386 amd64 kfreebsd-i386 kfreebsd-amd64 hurd-i386 lpia
 ifneq (,$(filter $(DEB_HOST_ARCH), $(UNALIGNED_ARCHS)))
 CFLAGS+=-DUNALIGNED_OK
 endif
 
-COPYLIST=*.h *.c *.in zlib.map configure zlib.3 test contrib
+COPYLIST=*.h *.c *.in zlib.map configure zlib.3 test
 
 configure-stamp: configure
 	dh_testdir
 
 	if [ ! -f Makefile.stash ]; then cp Makefile Makefile.stash ; fi
 
-	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" uname=GNU ./configure $(CONFIGURE_COMMON) $(CONFIGURE_HOST)
+	AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc" CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
 
 	cd contrib/minizip && autoreconf -fis && CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" uname=GNU ./configure --prefix=/usr --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
 
@@ -110,7 +90,7 @@
 	cp -r $(COPYLIST) debian/64
 	cd debian/64 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m64)" \
 	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
-	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/lib64
+	    uname=GNU ./configure --shared --prefix=/usr  --libdir=\$${prefix}/usr/lib64
 	touch $@
 
 configure32-stamp: configure
@@ -120,7 +100,7 @@
 	cp -r $(COPYLIST) debian/32
 	cd debian/32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(m32)" \
 	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
-	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/lib32
+	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
 	touch $@
 
 configuren32-stamp: configure
@@ -130,17 +110,7 @@
 	cp -r $(COPYLIST) debian/n32
 	cd debian/n32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mn32)" \
 	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
-	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/lib32
-	touch $@
-
-configurex32-stamp: configure
-	dh_testdir
-
-	mkdir -p debian/x32
-	cp -r $(COPYLIST) debian/x32
-	cd debian/x32 && AR=$(AR) CC="$(DEB_HOST_GNU_TYPE)-gcc $(mx32)" \
-	    CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" \
-	    uname=GNU ./configure $(CONFIGURE_COMMON) --libdir=\$${prefix}/usr/libx32
+	    uname=GNU ./configure --shared --prefix=/usr --libdir=\$${prefix}/usr/lib32
 	touch $@
 
 build: build-arch build-indep
@@ -171,11 +141,6 @@
 buildn32-stamp: configuren32-stamp
 	dh_testdir
 	make -C debian/n32
-	touch $@
-
-buildx32-stamp: configurex32-stamp
-	dh_testdir
-	make -C debian/x32
 	touch $@
 
 clean:
@@ -191,7 +156,6 @@
 	rm -rf debian/64 build64-stamp configure64-stamp
 	rm -rf debian/32 build32-stamp configure32-stamp
 	rm -rf debian/n32 buildn32-stamp configuren32-stamp
-	rm -rf debian/x32 buildx32-stamp configurex32-stamp
 	-mv Makefile.stash Makefile
 	-mv zlibdefs.h.stash zlibdefs.h
 
@@ -216,9 +180,6 @@
 
 installn32: install buildn32-stamp
 	$(MAKE) -C debian/n32 prefix=$(CURDIR)/debian/tmp install
-
-installx32: install buildx32-stamp
-	$(MAKE) -C debian/x32 prefix=$(CURDIR)/debian/tmp install
 
 # Build architecture-independent files here.
 binary-indep: build install
@@ -241,7 +202,7 @@
 	dh_strip -a --dbgsym-migration="zlib1g-dbg (<< 1:1.2.11.dfsg-2~)"
 	dh_compress -a
 	dh_fixperms -a
-	dh_makeshlibs -plibminizip1 -V"libminizip1 (>> 1:1.2.13.dfsg-1)"
+	dh_makeshlibs -plibminizip1t64 -V"libminizip1t64 (>> 1:1.2.13.dfsg-1)"
 	dh_makeshlibs -pzlib1g -V"zlib1g (>= 1:1.2.3.3.dfsg-1)" --add-udeb=zlib1g-udeb
 ifeq (,$(filter nobiarch,$(DEB_BUILD_PROFILES)))
 ifneq (,$(filter $(DEB_HOST_ARCH), $(32-ARCHS)))
@@ -252,9 +213,6 @@
 endif
 ifneq (,$(filter $(DEB_HOST_ARCH), $(N32-ARCHS)))
 	dh_makeshlibs -plibn32z1 -V"libn32z1 (>= 1:1.2.3.3.dfsg-1)"
-endif
-ifneq (,$(findstring $(DEB_HOST_ARCH), $(X32-ARCHS)))
-	dh_makeshlibs -plibx32z1 -V"libx32z1 (>= 1:1.2.3.3.dfsg-1)"
 endif
 endif
 	dh_installdeb -a

=== debian/tests/control ===
Tests: example, infcover, minigzip
Depends: @, gcc
Restrictions: allow-stderr, build-needed
